<?php

/**
  SendMail - a PmWiki recipe for sending email programatically
  (to respond to events such as page access, login or form submissions)
  Written by Kirk Siqveland 2020

  Usage:

  in your php code simple use

  send_mail($email,$message,$subject)
  where $email    is the address to use
        $message  is the content or "body"  of the message
        $subject  is subject line of the message

  the function will return a message indicating success or error
  the first character of the message is 
    1 for success or
    0 for fail / error

    ----------------------------------------------------------

  this is a very simple implementation, but with a little effort you can 
  easily expand the funciton to allow CC, BCC or even to add attachments.
  Just read the PHP Mailer documents or look for sample code online.


  This text is written for PmWiki; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version. See pmwiki.php for full details
  and lack of warranty.
*/



##_______________________________________________________________________________________________
##
##              <>>>>   PHPMailer Settings   <<<>
##_______________________________________________________________________________________________ 

## We need your Shell UserName for your Domain, to find your PHPMailer installation
	define(SHELLUSERNAME,  'shellusername')            ; // Usually your login name but in ftp / shell  the path looks
                                                       //       /home/shellusername/www.example.org
## Configure to your email server account
## If you are able to look at your email program's server settings you should be able to see all of this information.
	define(SMTPHOST,      'smtp.example.org')          ; // When sending smtp mail what is your host address?
	define(SMTPMAILUSER,  'wikiadmin@example.org')     ; // When sending email, what is you email login name
	define(SMTPMAILPW,    'S3cretP@ssword')            ; // The password you use to log in.

	define(SMTPFROM,      'wikiadmin@example.org')     ; // The email to show as FROM
	define(SMTPFROMTAG,   'My PMWiki Website')         ; // The tag to go with the FROM
	define(SMTPTOTAG,     'PMWiki Visitor')            ; // A tag to add to the TO

// Choose your Encryption
	define(SMTPENCRYPT,    'tls')							;        // This uses TLS encryption, comment these two lines and uncomment
	define(SMTPORT, 	     '587')							;        // the two below if you want to use SSL
	//define(SETENCRYPTION, 'ssl')							;
	//define(SETPORT, 	    '465')							;	




##---------------------------------------------------------------------------------
##		End of User Settings - Nothing below should need to change
##      - unless you have PHPMailer in a different directory -
##---------------------------------------------------------------------------------

## Import PHPMailer classes into the global namespace
## These must be at the top of your script, not inside a function
## This Assumes PHPMailer has been installed and is in its default directory
  use PHPMailer\PHPMailer\PHPMailer ;
  use PHPMailer\PHPMailer\Exception ;

## Change to your server - Username:
  require '/home/'.SHELLUSERNAME.'/PHPMailer/src/Exception.php'  ;
  require '/home/'.SHELLUSERNAME.'/PHPMailer/src/PHPMailer.php'  ;
  require '/home/'.SHELLUSERNAME.'/PHPMailer/src/SMTP.php'       ;

  session_start();

  function send_mail($email,$message,$subject)
  {      

    $mail = new PHPMailer(true) ;                 // Passing `true` enables exceptions
    
    try {
          //Assign Server settings
          $mail->SMTPDebug  = 0            ;      // Enable verbose debug output
          $mail->isSMTP()                  ;      // Set mailer to use SMTP
          $mail->Host       = SMTPHOST     ;      // Specify main and backup SMTP servers
          $mail->SMTPAuth   = true         ;      // Enable SMTP authentication
          $mail->Username   = SMTPMAILUSER ;      // SMTP username
          $mail->Password   = SMTPMAILPW   ;      // SMTP password
          $mail->SMTPSecure = SMTPENCRYPT  ;      // Enable TLS encryption, `ssl` also accepted
          $mail->Port       = SMTPORT          ;      // TCP port to connect to

          //Recipients
          $mail->setFrom(SMTPFROM, SMTPFROMTAG) ;      //This is the email your form sends From
          $mail->addAddress($email, SMTPTOTAG)  ;      // Add a recipient address
          //$mail->addAddress('contact@example.com') ; // Name is optional
          //$mail->addReplyTo('info@example.com', 'Information') ;
          //$mail->addCC('cc@example.com') ;
          //$mail->addBCC('bcc@example.com') ;

          //Attachments
          //$mail->addAttachment('/var/tmp/file.tar.gz') ;         // Add attachments
          //$mail->addAttachment('/tmp/image.jpg', 'new.jpg') ;    // Optional name

          //Content
          $mail->isHTML(true)       ;                              // Set email format to HTML
          $mail->Subject = $subject ;
          $mail->Body    = $message."<br ?>".getUserInfo() ;
          //$mail->AltBody = 'This is the body in plain text for non-HTML mail clients' ;

          $mail->send() ;

          return '1 - Message has been sent' ;

    } catch (Exception $e) 
    {
          $retStr = "0 - Message could not be sent. \r\n Mailer Error: ".$mail->ErrorInfo ;
          return $retStr ;
    }

  } //  /function send_mail

